<?xml version="1.0" encoding="utf-8"?>
<iso:schema xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:iso="http://purl.oclc.org/dsdl/schematron"
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://purl.oclc.org/dsdl/schematron"
    queryBinding='xslt2' schemaVersion='ISO19757-3'>

  <iso:ns prefix="xs" uri="http://www.w3.org/2001/XMLSchema"/>
  <iso:ns prefix="tp" uri="urn:riv:clinicalprocess:healthcond:certificate:types:3"/>
  	<iso:ns prefix="urn3" uri="urn:riv:clinicalprocess:healthcond:certificate:3"/>
	<iso:ns prefix="urn2" uri="urn:riv:clinicalprocess:healthcond:certificate:types:3"/>
	<iso:ns prefix="urn1" uri="urn:riv:clinicalprocess:healthcond:certificate:CreateDraftCertificateResponder:3"/>
	<iso:ns prefix="urn" uri="urn:riv:itintegration:registry:1"/>
	<iso:ns prefix="soapenv" uri="http://schemas.xmlsoap.org/soap/envelope/"/>

  <iso:pattern id="non-empty-string-pattern">
    <iso:rule id="non-empty-string" abstract="true">
      <iso:assert test="string-length(normalize-space(text())) > 0">Sträng kan inte vara tom.</iso:assert>
    </iso:rule>
  </iso:pattern>

  <iso:pattern id="boolean-pattern">
    <iso:rule id="boolean" abstract="true">
      <iso:assert test=". castable as xs:boolean">Kan bara vara 'true/1' eller 'false/0'</iso:assert>
    </iso:rule>
  </iso:pattern>

  <iso:pattern id="cv-pattern">
    <iso:rule id="cv" abstract="true">
      <iso:assert test="count(tp:cv) = 1">Ett värde av typen CV måste ha ett cv-element</iso:assert>
      <iso:assert test="count(tp:cv/tp:codeSystem) = 1">codeSystem är obligatoriskt</iso:assert>
      <iso:assert test="count(tp:cv/tp:code) = 1">code är obligatoriskt</iso:assert>
      <iso:assert test="count(tp:cv/tp:displayName) le 1">högst ett displayName kan anges</iso:assert>
    </iso:rule>
  </iso:pattern>

  <iso:pattern id="date-pattern">
    <iso:rule id="date" abstract="true">
      <iso:assert test=". castable as xs:date">Värdet måste vara ett giltigt datum.</iso:assert>
    </iso:rule>
  </iso:pattern>

  <iso:pattern id="period-pattern">
    <iso:rule id="period" abstract="true">
      <iso:assert test="tp:datePeriod">En period måste inneslutas av ett 'datePeriod'-element</iso:assert>
      <iso:assert test="tp:datePeriod/tp:start castable as xs:date">'from' måste vara ett giltigt datum.</iso:assert>
      <iso:assert test="tp:datePeriod/tp:end castable as xs:date">'tom' måste vara ett giltigt datum.</iso:assert>
      <iso:assert test="normalize-space(tp:datePeriod/tp:start) le normalize-space(tp:datePeriod/tp:end)">
        'from' måste vara mindre än eller lika med 'to'
      </iso:assert>
    </iso:rule>
  </iso:pattern>
  
  	
	<iso:pattern id="non-empty-elements-pattern">
    <iso:rule id="non-empty-elements" abstract="true">
		    <iso:assert test="normalize-space(.)">Element <iso:name /> is empty. All elements included in the response must have values.</iso:assert>
        </iso:rule>
    </iso:pattern>
	
	<iso:pattern id="Empty elements">
        <iso:rule context="soapenv:Body//*">
			<iso:extends rule="non-empty-elements"/>
		</iso:rule>
	</iso:pattern>	

</iso:schema>
